From 42c5b4f70dd3d3fd9b1aac6f42283db36cf0b697 Mon Sep 17 00:00:00 2001
From: Aashish Patel <aashishpatel@codeaurora.org>
Date: Wed, 18 Mar 2020 00:29:45 +0530
Subject: [PATCH] omxh264enc: enable vui timing info

---
 configure.ac        |  9 +++++++++
 omx/gstomxh264enc.c | 27 +++++++++++++++++++++++++
 2 files changed, 34 insertions(+)

diff --git a/configure.ac b/configure.ac
index 0d29ee4..8db3df7 100644
--- a/configure.ac
+++ b/configure.ac
@@ -260,6 +260,15 @@ AC_ARG_WITH([omx-header-path],
 if test x"$omx_header_path" != x"none"; then
     CPPFLAGS="$CPPFLAGS -I$omx_header_path"
 fi
+
+AC_ARG_ENABLE([vui-timing-info],
+            AC_HELP_STRING([--enable-vui-timing-info],[Enables VUI timing info in NAL]),
+        [vui_timing_info="${enableval}"], [vui_timing_info="no"])
+
+if test x"$vui_timing_info" != x"no"; then
+    CPPFLAGS="$CPPFLAGS -DENABLE_VUI_TIMING_INFO"
+fi
+
 dnl Check for external OpenMAX IL headers
 AC_CHECK_HEADER([OMX_Core.h], [HAVE_EXTERNAL_OMX=yes], [HAVE_EXTERNAL_OMX=no], [AC_INCLUDES_DEFAULT])
 AM_CONDITIONAL(HAVE_EXTERNAL_OMX, test "x$HAVE_EXTERNAL_OMX" = "xyes")
diff --git a/omx/gstomxh264enc.c b/omx/gstomxh264enc.c
index e46593a..fe55d4f 100644
--- a/omx/gstomxh264enc.c
+++ b/omx/gstomxh264enc.c
@@ -74,6 +74,17 @@ enum
 #define GST_OMX_H264_VIDEO_ENC_CONSTRAINED_INTRA_PREDICTION_DEFAULT (FALSE)
 #define GST_OMX_H264_VIDEO_ENC_LOOP_FILTER_MODE_DEFAULT (0xffffffff)
 
+#ifdef ENABLE_VUI_TIMING_INFO
+#ifndef __OMX_QCOM_EXTENSIONS_H__
+#define OMX_QcomIndexParamH264VUITimingInfo 0x7F000039
+typedef struct OMX_QCOM_VIDEO_PARAM_VUI_TIMING_INFO
+{
+  OMX_U32 nSize;            /** Size of the structure in bytes */
+  OMX_VERSIONTYPE nVersion; /** OMX specification version information */
+  OMX_BOOL bEnable;         /** Enable/disable the setting */
+} OMX_QCOM_VIDEO_PARAM_VUI_TIMING_INFO;
+#endif
+#endif
 
 /* class initialization */
 
@@ -593,6 +604,22 @@ gst_omx_h264_enc_set_format (GstOMXVideoEnc * enc, GstOMXPort * port,
   OMX_VIDEO_AVCPROFILETYPE profile = OMX_VIDEO_AVCProfileMax;
   OMX_VIDEO_AVCLEVELTYPE level = OMX_VIDEO_AVCLevelMax;
 
+#ifdef ENABLE_VUI_TIMING_INFO
+  OMX_QCOM_VIDEO_PARAM_VUI_TIMING_INFO vui_timing_info;
+
+  GST_OMX_INIT_STRUCT(&vui_timing_info);
+  vui_timing_info.bEnable = OMX_TRUE;
+  err =
+      gst_omx_component_set_parameter (GST_OMX_VIDEO_ENC (self)->enc,
+      OMX_QcomIndexParamH264VUITimingInfo, &vui_timing_info);
+  if (err != OMX_ErrorNone) {
+    GST_ERROR_OBJECT (self,
+        "can't set OMX_QcomIndexParamH264VUITimingInfo %s (0x%08x)",
+        gst_omx_error_to_string (err), err);
+    return FALSE;
+  }
+#endif
+
 #ifdef USE_OMX_TARGET_RPI
   GST_OMX_INIT_STRUCT (&config_inline_header);
   config_inline_header.nPortIndex =
-- 
2.7.4

